local spindash = true
local yeet = false

addHook("NetVars", function(net)
	spindash = net(spindash)
end)
addHook("SpinSpecial", function(p)
	if not spindash then return end
	if UM_SkinInfo(p.mo.skin).nospindash then return end
	if p.charability2 ~= CA2_SPINDASH then return end
	if not P_IsObjectOnGround(p.mo) then return true end
	return true
end)
addHook("PlayerThink", function(p)
	if UM_SkinInfo(p.mo.skin).nospindash then return end
	if not spindash then return end
	if p.charability2 ~= CA2_SPINDASH then return end
	if not P_IsObjectOnGround(p.mo) then return end
	if not p.mo.health then return end
	if p.cmd.buttons & BT_USE then
		if not (p.pflags & PF_STARTDASH) then
			p.mo.state = S_PLAY_SPINDASH
			if p.pflags & PF_SPINNING then
				p.dashspeed = p.speed/2
			else
				p.dashspeed = p.speed/4*3
			end
			p.pflags = p.pflags | (PF_STARTDASH | PF_SPINNING | PF_SPINDOWN)
		end
		p.mo.momx = p.mo.momx/1024*1000
		p.mo.momy = p.mo.momy/1024*1000
		if p.dashspeed < p.mindash/4*6 then p.dashspeed = p.mindash/4*6 end
		if p.dashspeed < p.maxdash then 
			if leveltime % 8 == 0 then
				S_StartSound(p.mo, sfx_spndsh)
			end
			p.camerascale = skins[p.mo.skin].camerascale
			p.dashspeed = $ + (FRACUNIT)
			if p.dashspeed > p.maxdash then
			
			end
		else
			p.dashspeed = $ + (FRACUNIT / 2)
			if leveltime % 12 == 0 and p.dashspeed < p.maxdash/2*3 then
				S_StartSound(p.mo, sfx_spndsh)
			end
			
			if p.dashspeed > p.maxdash/8*18 and yeet then
				if (unfunny) S_StartSound(p.mo, sfx_vboom)
				else S_StartSound(p.mo, sfx_bkpoof) end
				p.dashspeed = 0
				p.pflags = p.pflags & ~PF_STARTDASH
				p.cmd.buttons = p.cmd.buttons & ~BT_USE
				P_DoPlayerPain(p)
				local o = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_DRAGONMINE)
				o.target = p.mo
				p.mo.momz = $ * 6
				p.camerascale = skins[p.mo.skin].camerascale
				return
			end
		end
		P_SpawnSkidDust(p, p.mo.radius/4*3)
		P_SpawnSkidDust(p, p.mo.radius/4*3)
		p.pflags = p.pflags | (PF_STARTDASH)
	end
	if not (p.cmd.buttons & BT_USE) and p.pflags & PF_STARTDASH then
		if gametype == GT_RACE and leveltime < 4*TICRATE then
			return
		end
		p.pflags = (p.pflags & ~PF_STARTDASH) | PF_SPINNING
		p.mo.state = S_PLAY_ROLL
		p.camerascale = skins[p.mo.skin].camerascale
		p.dashspeed = min(p.dashspeed, p.maxdash/2*3)
		P_InstaThrust(p.mo, p.mo.angle, p.dashspeed)
		S_StartSound(p.mo, sfx_zoom)
		UM_SpawnThok(p)
		p.urmom.lastdash = 0
		p.dashspeed = p.mindash
	end
end)

-- Commands
COM_AddCommand("um_spindash", function(p, arg)
	local v = UM_StrBool(arg)
	if v ~= nil then spindash = v
	else
		CONS_Printf(p, "um_spindash [on/off] - Toggles whether or not the custom spindash can be used. Currently "
		+ UM_EnabledDisabled(spindash))
	end
end, COM_ADMIN)
COM_AddCommand("um_yeet", function(p, arg)
	local v = UM_StrBool(arg)
	if v ~= nil then yeet = v
	else
		CONS_Printf(p, "um_yet [on/off] - Toggles whether or not overcharging a spindash causes the player to get yeeted. Currently "
		+ UM_EnabledDisabled(yeet))
	end
end, COM_ADMIN)